<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 ** Component: cases
 **
 ** WEB interface for forward operations:
 **
 **  - Forwarding studies    (single/batch)
 **  - Burning studies to CD (single/batch)
 **  - Linking/Copying studies to folder (single/batch) 
 **
 **  Burning studies to CD is a special kind of Forward.
 **  Forward operations will be confirmed first.
 **
 **  @param cGr           Study Instance UID of study to be edited
 **  @param cBack         URL to go back after edit
 **  @param cOp           Forward operation ('Forward', 'Burn', 'Link')
 **  @param cTarget       List of target devices for Forward operation
 **  @param cKeepUpdated  Send modification (updates) automatically to target device(s)
 **  @param cStudy        Study Instance UID of the highlighted study
 **                       in case of batch open from relevant page
 **  @param cMediaSize    size of the media for Burn operation (in bytes minus 30 Mb for viewer)
 **
 *  Last Updated     : $Author$
 *  Update date/time : $Date$
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
-- %><%@page import="imagemed.http.tabs.TabBean"%>
<%@
	page import="imagemed.util.*,imagemed.types.*,imagemed.types.number.*,imagemed.types.string.*,imagemed.types.flag.IMTypeur,imagemed.exception.*,
			  imagemed.imsession.*,imagemed.jsputil.*,imagemed.http.IMRemoteHttpCommand,java.sql.*,java.util.*,java.io.*,
			  imagemed.dcprocessing.StudyForwarder,imagemed.dotcom.DotcomConfig, java.text.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	static IMTypeSSIZ m_typeSSIZ = ( IMTypeSSIZ ) IMType.getTypeFor( "SSIZ" );
	static IMTypePN m_typePN = ( IMTypePN ) IMType.getTypeFor( "PN" );

	static String m_tabPage = "cases/index.jsp";
	
	
	/**
	 * Figures out localized message to be displayed as page title from HTTP request parameters.
	 *
	 * @param is        Session stuff
	 * @param studies   Array of studies to be forwarded, burned, ...
	 * @param backURL   Link to page to go back when IMGeneralException is thrown
	 *
	 * @throws IMException on missing parameters or insufficient user rights
	 * @throws IOException if I/O error occurs
	 */
	static String getPageTitleFromParams( IMSession is, String[] studies, String backURL ) throws IMException, IOException, SQLException {
		 
		String parOp = is.request.getParameter( "cOp" );
		String pluralSuffix = studies.length > 1 ? "_PLURAL" : "";

		boolean hasForwardRight = is.hasRight( IMTypeur.FORWARD_EXPORT_RIGHT );
		boolean hasBurnLicense = is.tabbean.hasLicense(is, "8");
		
		ChoiceFormat studyPlural = LocalizedMessage.getStudyPluralChoice();
		ChoiceFormat toBeForwardedPlural = new ChoiceFormat( new double[]{ 1, 2 }, new String[]{ LocalizedMessage.getSimpleMessage( "CASES_FORWARD_TO_BE_FWD" ), LocalizedMessage.getSimpleMessage( "CASES_FORWARD_TO_BE_FWD_PLURAL" ) } );
		ChoiceFormat toBeCopiedTofolderPlural = new ChoiceFormat( new double[]{ 1, 2 }, new String[]{ LocalizedMessage.getSimpleMessage( "CASES_FORWARD_TO_BE_COPIED_TO_FOLDER" ), LocalizedMessage.getSimpleMessage( "CASES_FORWARD_TO_BE_COPIED_TO_FOLDER_PLURAL" ) } );
		ChoiceFormat toBeCreatedTofolderPlural = new ChoiceFormat( new double[]{ 1, 2 }, new String[]{ LocalizedMessage.getSimpleMessage( "CASES_FORWARD_TO_BE_CREATED_TO_FOLDER" ), LocalizedMessage.getSimpleMessage( "CASES_FORWARD_TO_BE_CREATED_TO_FOLDER_PLURAL" ) } );
		
		if ( "Forward".equals( parOp ) ) {
			// Forward operation requires Forward right
			if ( !hasForwardRight ) {
				throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FORWARD_NO_RIGHTS" ), m_tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FORWARD_NO_RIGHTS_TITLE" ), backURL, 4 );
			}

			String parTargetArray[] = is.request.getParameterValues( "cTarget" );
			StringBuffer targetList = new StringBuffer();
			if ( parTargetArray != null ) {
				for ( int i = 0; i < parTargetArray.length; i++ ) {
					targetList.append( ", " ).append( parTargetArray[ i ] );
				}
			}

			String targets = targetList.length() > 0 ? targetList.substring( 2 ) : targetList.toString();
			Format[] msgFormats = new Format[] { studyPlural, toBeForwardedPlural, null };
			Object[] msgArgs = new Object[] { studies.length, studies.length, targets };
			return LocalizedMessage.getCompoundMessage( "CASES_FORWARD_FORWARD_TO", msgFormats, msgArgs, true);
		}

		if ( "Burn".equals( parOp ) ) {
			// Burn operation requires Forward right and license
			if ( !hasForwardRight ) {
				throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BURN_NO_RIGHTS" ), m_tabPage, LocalizedMessage.getSimpleMessage ("EXCEPTION_CASES_BURN_ERROR_TITLE" ), backURL, 4 );
			}
			if ( !hasBurnLicense ) {
				throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BURN_NO_LICENSE" ), m_tabPage, LocalizedMessage.getSimpleMessage ("EXCEPTION_CASES_BURN_ERROR_TITLE" ), backURL, 4 );
			}
			
			return LocalizedMessage.getCompoundMessage( "CASES_FORWARD_PAGE_BURN", new Format[] { studyPlural }, new Object[] { studies.length }, true );
		}
		if ( "Link".equals( parOp ) ) {
			String folderName = null;
			String targetFolder = is.request.getParameter( "cToFolderName" );

			if ( "__WORKLIST__".equals( targetFolder ) ) {
				folderName = LocalizedMessage.getSimpleMessage( "LINK_FORM_TARGET_WORKLIST" );
			}
			else if ( "__ADD_NEW__".equals( targetFolder ) ) {
				folderName = is.request.getParameter( "cToFolderUser" ) + "/" + is.request.getParameter( "cNewFolderName" );
			}
			else {
				folderName = is.request.getParameter( "cToFolderUser" ) + "/" + is.request.getParameter( "cToFolderName" );
			}
			if ( folderName == null ) {
				folderName = "";
			}
			Format[] msgFormats = new Format[] { studyPlural, toBeCreatedTofolderPlural, null };
			Object[] msgArgs = new Object[] { studies.length, studies.length, folderName };
			
			if ( "true".equals( is.request.getParameter( "cIsCopy" ) ) ) {
				if ( !is.hasRight( PacsRight.Copy.letterString() ) ) {
					throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_COPY_NO_RIGHTS" ), m_tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_COPY_ERROR_TITLE" ), backURL, 4 );
				}
				msgFormats = new Format[] { studyPlural, toBeCopiedTofolderPlural, null };
				msgArgs = new Object[] { studies.length, studies.length, folderName };
				return LocalizedMessage.getCompoundMessage( "CASES_FORWARD_FOLDER_COPY", msgFormats, msgArgs, true);
			}

			return LocalizedMessage.getCompoundMessage( "CASES_FORWARD_FOLDER_LINK", msgFormats, msgArgs, true);
		}
		
		return LocalizedMessage.getCompoundMessage( "CASES_FORWARD_FORWARD", new Format[] { studyPlural, toBeForwardedPlural }, new Object[] { studies.length, studies.length }, true );
	}

%><%-- Input Parameters -- %><%

	IMSession is = new IMSession( request, response, out );
	boolean useUncompressedSizes = false;

	String parBack = request.getParameter( "cBack" );

	if ( null == parBack ) {
		parBack = request.getHeader( "Referer" );
	}
	if ( null == parBack ) {
		parBack = "javascript:self.history.back();";
	}

	is.regDest = parBack;

	if (! is.regOK() ) {
		return;
	}
	
	Defs casesDefs = new Defs( is, null );
	boolean isAdmin = is.hasRight( PacsRight.Admin.letterString() );
	boolean hasForwardRight = is.hasRight( IMTypeur.FORWARD_EXPORT_RIGHT );
	boolean hasBurnLicense = is.tabbean.hasLicense(is, "8");


	String[] parGrArray = request.getParameterValues( "cGr" );


	if ( parGrArray == null || parGrArray.length == 0 ) {
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FORWARD_NO_STUDIES" ), m_tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FORWARD_OP_ERROR_TITLE" ), parBack, 4 );
	}

	Set<String> validTargets = IMAdminToolbox.getForwardTargets( is.regID );

	boolean residesMultipleHubs = false;
	
	// Indicates whether a media creation can be started
	boolean canCreateMedia = hasForwardRight && hasBurnLicense && 
	( validTargets.contains( IMTypefw.MEDIA ) || validTargets.contains( IMTypefw.ALLDEVS ) );

	
	// Check and redirect page to HUB from CWL server
	if ( DotcomConfig.selfDevice().isDbOnly() ) {
		// Check if all of the selected studies reside on the same HUB and redirect

		String idBase = RedirectToolbox.getRedirectForStudy( is, parGrArray[ 0 ] );
		String tempSTUIDs = "&cGr=" + Helper.URLEncodeUTF8( parGrArray[ 0 ] );
		
		for ( int i = 1; i < parGrArray.length ; i++ ) {
	String id = RedirectToolbox.getRedirectForStudy( is, parGrArray[ i ] );
	tempSTUIDs+= "&cGr=" + Helper.URLEncodeUTF8(parGrArray[ i ] );
	
	if ( idBase != id ) {
		residesMultipleHubs = true;
		if ( !canCreateMedia ) {
			// Selecting studies residing at multiple hubs is only allowed for media creation
			StringBuilder sb = new StringBuilder( 512 );
			MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FORWARD_OP_ERROR_TITLE" ), "" );
			sb.append( "<H3>" ).append( LocalizedMessage.getSimpleMessage( "CASES_FORWARD_MULTIHUB_SELECTED" ) ).append( "<BR>" )
					.append( LocalizedMessage.getSimpleMessage( "CASES_FORWARD_MULTIHUB_EXPLANATION" ) ).append( "</H3>" );

			mb.setMessage( sb.toString() );
			throw new IMMessageBoxException( is, mb, m_tabPage, 0, parBack );
		}
	}
		}

		if ( ! residesMultipleHubs ) {
	StringBuffer sbParams = new StringBuffer(256);
	if (request.getParameter( "cBack" ) != null) {
		sbParams.append( "&cBack=" ).append( Helper.URLEncodeUTF8( request.getParameter( "cBack" ) ) );
	}
	if (request.getParameter("cOp") != null) {
		sbParams.append( "&cOp=" ).append( Helper.URLEncodeUTF8( request.getParameter( "cOp" ) ) );
	}
	
	sbParams.append( tempSTUIDs ).append( "&ParentSession=" ).append( Helper.URLEncodeUTF8( is._sid ) );
	
	String refererHost = request.getParameter( "RefererHost" );
	if ( refererHost == null ) {
		sbParams.append( "&RefererHost=" ).append( RedirectToolbox.getThisHostEnc( is ) );
	}
	else {
		sbParams.append( "&RefererHost=" ).append( Helper.URLEncodeUTF8( refererHost ) );
	}
	
	 		response.sendRedirect( idBase+ "/cases/forward.jsp" + "?" + sbParams );
	return;
		}
	} 


	// Page Header and table of studies to be forwarded
	String titleMessage = getPageTitleFromParams( is, parGrArray, parBack );
	
	String parGr = null;
	String linkGr = null;
	String whereGr = null;

	{
		StringBuffer sbGr = new StringBuffer( 128 );
		StringBuffer sbLinkGr = new StringBuffer( 128 );
		StringBuffer sbWhereGr = new StringBuffer( 128 );

		for ( int i = 0; i < parGrArray.length; i++ ) {
	sbGr.append( " " ).append( parGrArray[ i ] );
	sbLinkGr.append( "&cGr=" ).append( parGrArray[ i ] );
	sbWhereGr.append( " OR STYIUID='" ).append( parGrArray[ i ] ).append( "'" );
		}

		parGr = sbGr.substring( 1 );
		linkGr = sbLinkGr.substring( 1 );
		whereGr = sbWhereGr.substring( 4 );
	}

	
	// Check total size

	long tsize = 0;
	
	String query = "select SUM(SUMSIZE) as s from " + IMEnvBase.getEnv("STUDYTBL") + " where " + whereGr;
	try ( ResultSet result = IMEnv.getDB().createStatement().executeQuery( query ) ) {
		if ( result.next() ) {
			try {
				tsize = Long.parseLong( result.getString( "s" ) );
			}
			catch ( NumberFormatException nfe ) {
			}
		}
	}

	String stsize = m_typeSSIZ.display( Long.toString( tsize ) ,null, null );



%><HTML>
<HEAD>
<TITLE><%=LocalizedMessage.getSimpleMessage( "OPER_FORWARD" )%></title>
<%
	TabToolbox.writeIMpopup( out );
	imagemed.http.tabs.TabBean.writeStyleOnly( is );
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( is );

	String parOp = request.getParameter("cOp");

	if ( "Burn".equals( parOp ) ) {
		UserPreferences.guiPrintJSInclude( is );
	}

%>

<SCRIPT language="JavaScript">
	function Jump_( pJ ) {
		document.location = pJ;
	}

	function turnOffAll( name ) {
		var changed = false;
		for ( var i = 0; i < document.forms.length; i++ ) {
			var form = document.forms[ i ]
			for ( var j = 0; j < form.elements.length; j++ ) {
				var element = form.elements[ j ];
				if ( element.name == name && element.checked ) {
					element.checked = false;
					changed = true;
				}
			}
		}
		if ( changed ) {
			alert( "<%=LocalizedMessage.getSimpleMessage( "CASES_FORWARD_ALERT_ONLY_ONE_OP" )%>" );
		}
		return changed;
	}

	function refresh() {
		var form = self.document.operForm;
		form.cOp.value = '';
		while ( form.cOp.value != '' ) {
			form.cOp.value = '';
		}
		if ( !form.cToFolder.checked ) {
			form.cToFolder.checked = true;
			turnOffAll( 'cTarget' );
			turnOffAll( 'cBurn' );
		}
		form.submit();
	}

	function setToFolder() {
		var form = self.document.operForm;
		turnOffAll( 'cTarget' );
		turnOffAll( 'cBurn' );
		if ( !form.cToFolder.checked ) {
			form.cToFolder.checked = true;
		}
	}

	
	function folderSelected() {
		var form = self.document.operForm;
		var options = form.cToFolderName.options;
		for ( var i = 0;  i < options.length; i++ ) {
			if ( options[ i ].selected ) {
				if ( options[ i ].value == "__ADD_NEW__" ) {
					form.cNewFolderName.disabled = false;
					form.cToFolderUser.disabled = false;
				}
				else if ( options[ i ].value == "__WORKLIST__" ) {
					form.cNewFolderName.disabled = true;
					form.cToFolderUser.disabled = true;
				}
				else {
					form.cNewFolderName.disabled = true;
					form.cToFolderUser.disabled = false;
				}
			}
		}
	}
	
	function onFolderSelected() {
		setToFolder();
		folderSelected();
	}

	function doSubmit() {
		var form = self.document.operForm;
		var oper = '';
		for ( var j = 0; j < form.elements.length; j++ ) {
			var element = form.elements[ j ];
			if ( element.name == 'cTarget' && element.checked ) {
				oper = 'Forward';
			}
			else if ( element.name == 'cToFolder' ) {
				if ( element.value == 'false' || element.checked ) {
					// value is false if element is a hidden input field (user has no forward rights)
					oper = 'Link';
				}
			}
			else if ( element.name == 'cBurn' ) {
				if ( element.value == 'false' || element.checked ) {
					// value is false if element is a hidden input field (studies reside at multiple hubs)
					oper = 'Burn';
				}
			}
		}

		if ( '' == oper ) {
			oper = 'Forward';
		}

		form.cOp.value = oper;
		form.submit();
	}
	
	function goBack() {
		document.location = '<%=parBack%>';
	}

</script>

</head>
<BODY>
<DIV class="fob" id="pnFOB" style="display:none"></DIV>

<%
	TabToolbox.makeTabs( is, is.tabbean, "cases/index.jsp", "White" );
%>
<FONT face="Arial,Helvetica,Universe">
<%

	StringBuffer sbPassForm = new StringBuffer( 256 );
	sbPassForm.append( Helper.passAsForm( "cGr", parGrArray ) );
	sbPassForm.append( Helper.passAsForm( "cBack", new String[] { parBack } ) );
	sbPassForm.append( Helper.passAsForm( "cStSize", new String[] { stsize } ) );

	String refererHost = request.getParameter( "RefererHost" );
	if ( refererHost != null ) {
		sbPassForm.append( Helper.passAsForm( "RefererHost", new String[] { refererHost } ) );
	}

	OperToolbox.CheckedStudies checkedStudies = OperToolbox.getForwardableStudies( parGrArray );

	for ( String badstudy : checkedStudies.getBadStudies() ) {
		out.println( "<!-- Bad study: " + badstudy + " -->" );
	}

	for ( String goodstudy : checkedStudies.getGoodStudies() ) {
		out.println( "<!-- Good study: " + goodstudy + " -->" );
	}

	
	Map<String, OperToolbox.RowHighlight> highlights = null;
	if ( checkedStudies.hasBadStudy() ) {
		highlights = new HashMap<String, OperToolbox.RowHighlight>();
		OperToolbox.RowHighlight errorHL = new OperToolbox.RowHighlight("BgErrorRow", null, null);
		for ( Iterator<String> i = checkedStudies.getBadStudies().iterator(); i.hasNext(); ) {
	highlights.put( i.next(), errorHL );
		}
	}
	
	OperToolbox.InfoTable infoTable = OperToolbox.getPatientNames( parGrArray, is, true, useUncompressedSizes, highlights );

	if ( useUncompressedSizes ) {
		tsize = infoTable.getUncompressedSize();
		stsize = m_typeSSIZ.display( Long.toString( tsize ), null, null );
	}

	String patientTable = infoTable.getStudiesTable();
	
%>
 <TABLE border=1 width="100%" cellpadding=0 cellspacing=0 class=BgShadow>
  <TR><TD style="padding-top: 10; padding-bottom: 10;">
  <TABLE border=0 width="100%"><TR><TD>
   &nbsp;&nbsp;
   <FONT size=4>
   <%=titleMessage%>:
   </FONT>
  </TD></TR></TABLE>
  </TD></TR><TR><TD>
   <%=patientTable%>
   <center><b>
   <%=LocalizedMessage.getSimpleMessage( "CASES_FORWARD_TOTAL_SIZE" )%>: <%=stsize%>
   </b></center>
  </TD></TR>
 </TABLE>

<%
	String errFontB = "<FONT color=red><B>";
	String errFontE = "</b></FONT>";
	// Perform actual forward operations
	try {

		// Is there any study could not be forwarded
		if ( checkedStudies.hasBadStudy() ) {
	String titleID = "Burn".equals( parOp ) ? "EXCEPTION_CASES_BURN_ERROR_TITLE" : "EXCEPTION_CASES_FORWARD_NO_RIGHTS_TITLE";
	String errorMessageID = "";
	if ( checkedStudies.getBadStudies().size() > 1 )
		errorMessageID = "Burn".equals( parOp ) ? "EXCEPTION_CASES_BURN_UNFORWARDABLE_PLURAL" : "EXCEPTION_CASES_FORWARD_UNFORWARDABLE_PLURAL";
	else
		errorMessageID = "Burn".equals( parOp ) ? "EXCEPTION_CASES_BURN_UNFORWARDABLE" : "EXCEPTION_CASES_FORWARD_UNFORWARDABLE";
	
	MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( titleID ), "" );
		
	mb.setMessage( "<BR>" + errFontB + LocalizedMessage.getSimpleMessage( errorMessageID ) + errFontE + "<BR><BR>" );
		
	if (parOp == null && checkedStudies.getGoodStudies().size() > 0) {
		// we may go on with the rest...
		
		out.println( "<FORM name=\"operForm\" method=\"POST\" action=\"forward.jsp\">" );
		mb.addButton(new Button( "JavaScript:document.operForm.submit();", "BUTTON_SKIP_THEM", "ALT_TEXT_SKIP_THEM" ) );
		
		Enumeration<?> enum0 = request.getParameterNames();
		while ( enum0.hasMoreElements() ) {
			String name = ( String ) enum0.nextElement();
			String[] values = request.getParameterValues( name );
			for ( int i = 0; values != null && i < values.length; i++ ) {
				String value = values[ i ];
				if (value == null) {
					value = "";
				}
				if ( !checkedStudies.getBadStudies().contains( value ) ) {
					out.println( "<input type=hidden name=\"" + name + "\" value=\"" + value + "\">" );
				}
				else {
					out.println("<!-- skipping : "+name+" -> "+value+"-->");
				}
			}
		}
	}
	
	throw new IMMessageBoxException( is, mb, m_tabPage, 0, parBack );
		}
		
		// Check and start forwarding
		if ( "Forward".equals ( parOp ) ) {
	// forwarding -------------------------------------------------
		
	String parTargetArray[] = request.getParameterValues( "cTarget" );
	if ( parTargetArray == null || parTargetArray.length == 0 ) {
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FORWARD_NO_TARGET" ) , m_tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FORWARD_OP_ERROR_TITLE" ), null, 3 );
	}
		
	// --- Execute forwarding, go to cBack then ---
		
	StringBuffer targetList = new StringBuffer();
	targetList.append("\n");
	for ( int i = 0; i < parTargetArray.length; i++ ) {
		targetList.append( "\n" ).append( parTargetArray[ i ] );
		boolean keepSendingUpdates = "true".equals(request.getParameter("sendingUpdates_" + parTargetArray[i]));
		boolean reportOnly = "true".equals(request.getParameter("reportOnly_" + parTargetArray[i]));
	
		// StudyForwarder.forwardStudies( null, checkedStudies.getGoodStudies(), parTargetArray[i], casesDefs.getUser(), keepSendingUpdates, reportOnly );
		StudyForwarder.createForwardTask( null, checkedStudies.getGoodStudies(), parTargetArray[i], casesDefs.getUser(), keepSendingUpdates, reportOnly );
	}
	
	targetList.append("\n\n");
	Format[] msgFormat = new Format[] { LocalizedMessage.getStudyPluralChoice(), null };
	Object[] msgArgs = new Object[] { checkedStudies.getGoodStudies().size(), targetList.toString() };
	
	MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "CASES_FORWARD_STARTED_TITLE" ), "" );
	mb.setMessage( "<h3>" + LocalizedMessage.getCompoundMessage( "CASES_FORWARD_STARTED_MSG", msgFormat, msgArgs, true ) + "</br></h3>" );
	throw new IMMessageBoxException( is, mb, "cases/index.jsp", 4, parBack );
		} // end of Forward

		else if ( "Burn".equals( parOp ) ) {
	// CD Burning
	// Do some extra checking here, a form for passing data to cd/burncd.jsp will be 
	// Printed in the HTML section

	// Check total size
//			String parMaxSize = request.getParameter("cMediaSize");
//			long maxSize = OperToolbox.getMaxCapacity(parMaxSize);
//			if (tsize > maxSize) {
//				macros.setProperty( "SIZE", stsize );
//				macros.setProperty( "MAXSIZE", parMaxSize );
//				throw new IMGeneralException( "BURN_SIZE_PROBLEM", macros, "cases/index.jsp", LocalizedMessage.getSimpleMessage ("EXCEPTION_CASES_BURN_ERROR_TITLE" ), null, parBack, 0 );
//			}
		} // end of Burning


		else if ( "Link".equals( parOp ) ) {
	// Create Copy/Shortcut to folder/worklist
		
	String folderUN = null;
	String targetFolder = is.request.getParameter( "cToFolderName" );
	
	if ( "__WORKLIST__".equals( targetFolder ) ) {
		// Copy / Link target is the worklist 
		folderUN = null;
	}
	else if ( "__ADD_NEW__".equals( targetFolder ) ) {
		// Create new folder
	
		folderUN = request.getParameter( "cToFolderUser" ) + "/" + request.getParameter( "cNewFolderName" );
		try {
			FolderToolbox.createFolder( is, folderUN );
		}
		catch ( IMException re ) {
			int level = 2;
			if ( is.isMSIE() ) {
				level=1;
			}
		
			out.println( "<form name=\"errorBackForm\" method=post>" );
			out.println( " <input type=hidden name=\"cBack\" value=\"" + parBack + "\">" );
			for (int i=0; i<parGrArray.length; i++) {
				out.println(" <input type=hidden name=\"cGr\" value=\""+parGrArray[i]+"\">");
			}
			out.println( "</form>" );
		
			Format[] msgFormat = new Format[] { LocalizedMessage.getStudyPluralChoice() };
			Object[] msgArgs = new Object[] { parGrArray.length };
		
			MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_FORWARD_NO_RIGHTS_TITLE" ), "" );
			StringBuilder sb = new StringBuilder();
			sb.append( "<H3><FONT color=\"red\">" );
			sb.append( LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_LINK_FOLDERCREATION_FAILED", msgFormat, msgArgs, true ) );
			sb.append( ":<BR>" );
			sb.append( re.getMessage() );
			sb.append( "</FONT></H3>" );
			mb.setMessage( sb.toString() );
		
			throw new IMMessageBoxException( is, mb, "cases/index.jsp", 3, "JavaScript:document.errorBackForm.submit();" );
		}
	}
	else {
		folderUN = request.getParameter( "cToFolderUser" ) + "/" + request.getParameter("cToFolderName");
	}
	
	StringBuffer warning = new StringBuffer();
	boolean isCopy = "true".equals( request.getParameter( "cIsCopy" ) );
	for ( int i = 0; i < parGrArray.length; i++ ) {
		try {
			FolderToolbox.addToFolder( is, folderUN, parGrArray[i], isCopy, null );
		}
		catch (RuntimeException re) {
			warning.append( re.getMessage() ).append( "<br>" );
		}
	}
	
	Format[] msgFormat = new Format[] { LocalizedMessage.getStudyPluralChoice() };
	Object[] msgArgs = new Object[] { parGrArray.length };
		
	MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "CASES_FORWARD_LINK_COMPLETED_TITLE" ), "" ) ;
	StringBuilder sb = new StringBuilder();
	sb.append( "<H3>" );
	sb.append( LocalizedMessage.getCompoundMessage( "CASES_FORWARD_LINK_COMPLETED_MESSAGE" , msgFormat, msgArgs, true) );
	if ( warning.length() > 0 ) {
		sb.append( "<BR><BR>" );
		sb.append( LocalizedMessage.getSimpleMessage( "GENERAL_WARNING_TITLE" ) );
		sb.append( ":<BR>" + warning );
	}
	sb.append( "</H3>" );
	mb.setMessage( sb.toString() );
		
	throw new IMMessageBoxException( is, mb, "cases/index.jsp", warning.length() == 0 ? 3 : 0, parBack );
		} // End of link

		// Print HTML content 

		if ( "Burn".equals( parOp ) ) {

	// START BURN CD form
		
	UserPreferences prefs = new UserPreferences( is.regID );
	prefs.load();
		
	String viewerPref = prefs.getPreference( "burn_add_viewer" );
	String srPref = prefs.getPreference( "burn_omit_sr" );
	String mediaTypePref = prefs.getPreference( "burn_media_type" );
	String compressionPref = prefs.getPreference( "burn_compression" );
			String profileUserPref = prefs.getPreference( "burn_profile_user" );
		
	String warnSpan = "<SPAN id=up_media_warning_compression style=\"font-style: italic\"></SPAN> ";
%>
 <BR>
 <TABLE border=1 align=center cellpadding=2 cellspacing=0 class=BgShadow>
  <FORM action="/cd/createMedia.jsp" name="burnForm" method="POST">
  <TR><TD colspan=2 style="padding-top: 10; padding-bottom: 10;">
   &nbsp;&nbsp;<B><%=LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTIONS" )%>:</B>
  </TD></TR>

<%

	//	UserPreferences.guiPrintSectionHeaderRow( is, IMEnv.getLocalMessage( "BURN_MEDIA_OPTIONS" ) );


	UserPreferences.RawElem warningSpan = new UserPreferences.RawElem(
			"<SPAN ID=up_media_warning style=\"color: Gold; visibility:hidden\">" +
			LocalizedMessage.getCompoundMessage( "BURN_MEDIA_OPTION_MEDIA_PROFILE_WARNING", new Format[] { null }, new Object[] { warnSpan }, true ) + "</SPAN>" );
		
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTION_MEDIA_TYPE" ),
			UserPreferences.SELECT_MEDIA_TYPE, mediaTypePref );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTION_MEDIA_PROFILE" ),
			new UserPreferences.Elem[] { UserPreferences.SELECT_MEDIA_COMPRESSION, warningSpan }, compressionPref );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTION_ADD_VIEWER" ),
			new UserPreferences.Checkbox( UserPreferences.getFormName( "burn_add_viewer" ), "true" ), viewerPref );
	UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_OPTION_OMIT_SR" ),
			new UserPreferences.Checkbox( UserPreferences.getFormName( "burn_omit_sr" ), "true" ), srPref );
		
			SelectUserProfile sup = UserPreferences.getSelectForUserprofile( is );
			UserPreferences.guiPrintSettingRow( is, LocalizedMessage.getSimpleMessage( "BURN_MEDIA_PROFILE_USER" ),
			sup, sup.getCurrentValue( is, profileUserPref ) );
/*
	is.out.println( "<tr>" );
	is.out.print( " <td class=\"BgMedDark\" style=\"white-space: nowrap; padding-left: 15;\" width=\"35%\">" );
	is.out.print( LocalizedMessage.getSimpleMessage( "BURN_MEDIA_PROFILE_USER" ) );
	is.out.println( " </td>" );
	is.out.println( " <td align=\"left\" class=\"BgContrast\" style=\"white-space: nowrap; padding-left: 15;\">" );
	is.out.println( "<SELECT name=\"profileUser\">" );
	
	DualPropsConfigReader burnCfg = new DualPropsConfigReader( IMEnvBase.getEnv( "CONF" ) + "/cdburn.conf", IMEnvBase.getEnv( "CASES_HOME" ) + "/cfg/cdburn.conf" );
	IMProperties burnProps = burnCfg.getProperties();
	String defUser = burnCfg.getProperty( "profileuser", DicomSrvToolbox.PROFILE_USER_SELF );  
	
	if( defUser.equals( DicomSrvToolbox.PROFILE_USER_SELF ) ) {
		defUser = is.regID;
	}

	if( is.hasRight( PacsRight.Admin.letterString() ) ) {
		try {
			PreparedStatement stUser = IMEnv.getDB().prepareStatement( "SELECT USERID FROM Access ORDER BY USERID" );
			ResultSet resUser = stUser.executeQuery();
			while ( resUser.next() ) {
				String userID = resUser.getString( "USERID" );
				if ( userID != null ) {
					is.out.print( DicomSrvToolbox.getOption( userID, userID, defUser ) );
				}
			}
		}
		catch ( Throwable th ) {
			Helper.defaultCatch( th );
		}
		
	}
	else {
		is.out.print( DicomSrvToolbox.getOption( defUser, defUser, defUser ) );
		if( !defUser.equals( is.regID ) ) {
			is.out.print( DicomSrvToolbox.getOption( is.regID, is.regID, defUser ) );
		}
	}
	
	is.out.println( "</td>" );
	is.out.println( "</tr>" );
*/
%>
  <SCRIPT language="JavaScript">resetMediaProfiles( '<%= mediaTypePref %>','<%= compressionPref %>' );</script>

  <TR><TD class=BgShadow nowrap colspan=2 align=center style="padding-top: 10; padding-bottom: 10;">
   <b><%= LocalizedMessage.getSimpleMessage( "BURN_MEDIA_CONFIRM_LONG_TIME" ) %></b>
  </TD></TR>

  <TR><TD class=BgShadow nowrap colspan=2 align=center style="padding-top: 10; padding-bottom: 10;">
   <TABLE border=0 cellpadding=0 cellspacing=0 width="100%"><TR>
    <TD align=left valign="middle">
    	&nbsp;&nbsp;<INPUT TYPE=CHECKBOX NAME="cSetDefault" VALUE="true">
    	<%= LocalizedMessage.getSimpleMessage( "BURN_SET_AS_DEFAULT" ) %>&nbsp;&nbsp;
    </TD>
    <TD nowrap align="right" valign="middle">
     &nbsp; &nbsp; &nbsp; &nbsp;
     <a href="javascript:self.document.burnForm.submit();">
     	<%= JSHelper.getJsLocalizedButton( "BUTTON_CONTINUE", "BUTTON_NULL", false )  %>
     </a>
     &nbsp; &nbsp; &nbsp; &nbsp;
     <a href="<%=parBack%>"><%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %></a>
     &nbsp; &nbsp; &nbsp; &nbsp;
    </TD>
   </TR></TABLE>
  </TD></TR>

  <TR>
   <TD colspan=2 class=FieldBlock style="padding-top: 0; height: 18;"><font size=0>&nbsp;</font></td>
  </TR>

  <%= sbPassForm.toString() %>
  <INPUT TYPE=hidden name=cStart value=true>
  </FORM>
 </TABLE>
 </BODY>
</HTML>
<%
			return;
		}
		// END BURN CD form

	

// --- HTML II ------------------------------------------------------------


		// --- Prepare forwarding ---
		

%>

<br>
<FORM name="operForm" method="POST" action="forward.jsp">
<INPUT type=hidden name=cOp value="">
<TABLE border=1 width="100%" cellpadding=0 cellspacing=0>
 <TR><TD class=BgShadow colspan=7>
  <BR>
  <TABLE border=0 width="100%"><TR><TD>
   &nbsp;&nbsp;
   <FONT size=4>
   <%= LocalizedMessage.getSimpleMessage("CASES_FORWARD_SELECT_TARGET") %>:
   </FONT>
  </TD></TR></TABLE>
  <BR>
 </TD></TR>
<%

		if ( residesMultipleHubs ) {
			// Only media creation is allowed
%>
 <TR><TD align="center" class=BgShadow colspan=7 style="padding: 10px; font-size: large;">
   <%= LocalizedMessage.getSimpleMessage( "CASES_FORWARD_MULTIHUB_SELECTED" ) %><BR>
   <%= LocalizedMessage.getSimpleMessage( "CASES_FORWARD_MULTIHUB_MEDIACREATION" ) %>
 </TD></TR>
<%
		}


		if ( hasForwardRight && !residesMultipleHubs ) {
			
			out.println(Helper.header3D(" " + 
					LocalizedMessage.getSimpleMessage( "GENERIC_SELECT" ) +	"  ,  " + 
					LocalizedMessage.getSimpleMessage( "GENERIC_NAME" ) + "  ,  " + 
					LocalizedMessage.getSimpleMessage( "GENERIC_HOST" ) + "  ,  " + 
					LocalizedMessage.getSimpleMessage( "GENERIC_PORT" ) + "  ,  " + 
					LocalizedMessage.getSimpleMessage( "GENERIC_AE" ) +	"  ,  " + 
					LocalizedMessage.getSimpleMessage( "GENERIC_SENDING_UPDATES" ) + "  ,  " + 
					LocalizedMessage.getSimpleMessage( "GENERIC_REPORT_ONLY" ) + "  "));
			
				String qTarget = "select * from " + IMEnvBase.getEnv("TARGETTBL") + "," + IMEnvBase.getEnv("DEVSERVTBL") +
						" WHERE ID=DEVICE AND SERVICE='StrP' order by ID";

			try ( ResultSet resultTarget = IMEnv.getDB().createStatement().executeQuery(qTarget) ) {
				while ( resultTarget.next() ) {
					if (imagemed.dotcom.DotcomConfig.isParentDbOnly() && "P".equals(resultTarget.getString("TYPE"))) {
						continue;
					}
					String name  = resultTarget.getString("ID");
					
					if( !validTargets.contains( name ) && 
							!validTargets.contains( IMTypefw.ALLDEVS ) ) {
						continue;
					}
					
					String nameC = Helper.htmlEncode(name);
					String ae = resultTarget.getString("AE");
					DeviceConfig devQR = new DeviceConfig(name);
					boolean sendingUpdates = devQR.getSendingUpdates() == DeviceConfig.DcBool.TRUE;
					
					if (ae == null)
						ae = "";
%>
 <TR>
  <TD align="center" class=BgContrast>
   <INPUT type=checkbox name=cTarget value="<%=nameC%>" onFocus="if (turnOffAll('cBurn') || turnOffAll('cToFolder')) {checked=true;}">
  </td><TD class=BgMedDark>
   <%=nameC%>
  </td><TD class=BgShadow>
   <%= resultTarget.getString("HOSTNAME")%>&nbsp;
  </td><TD class=BgShadow>
   <%= resultTarget.getString("PORT")%>&nbsp;
  </td><TD class=BgShadow>
   <%= ae%>&nbsp;
  </td><TD class=BgShadow>
   <INPUT TYPE="CHECKBOX" NAME="sendingUpdates_<%= nameC %>" VALUE="true"<%= sendingUpdates ? " CHECKED" : "" %>> &nbsp;
  </td><TD class=BgShadow>
   <INPUT TYPE="CHECKBOX" NAME="reportOnly_<%= nameC %>" VALUE="true">&nbsp;
  </td>
 </tr>
<%
				}
			}
			catch ( Throwable th ) {
				out.println( "\n<!--" + th.toString() + "-->" );
			}
		}
   
	  	if ( !residesMultipleHubs && (validTargets.contains( IMTypefw.FOLDER ) || validTargets.contains( IMTypefw.ALLDEVS ) ) ) {
				FolderToolbox.printFolderFwdForm( "  ", is );
	  	}
  	
		if ( hasForwardRight && is.tabbean.hasLicense( is, "8" ) && 
				( validTargets.contains( IMTypefw.MEDIA ) || validTargets.contains( IMTypefw.ALLDEVS ) ) ) {

%>
 <TR>
  <TD align="center" class=BgContrast>
<%
			if ( residesMultipleHubs ) {
				// this is the only valid operation - check by default
				// Use the same format as FolderToolbox.printFolderFwdForm( "  ", is );
				// value of 'false' indicates it's a hidden field for the only available target
%>
  <INPUT type="hidden" name="cBurn" value="false" />
  <%= JSHelper.getJsImage( is, "/imadmin/art/checkgs", "" ) %>
<%
			}
			else {
%>
   <INPUT type=checkbox name=cBurn value="Create DICOM CD" onFocus="if (turnOffAll('cTarget') || turnOffAll('cToFolder')) {checked=true; }">
<%
			}
%>
  </TD>
  <TD class=BgShadow nowrap colspan=6>
   <%= LocalizedMessage.getSimpleMessage( "BURN_CREATE_DICOM_MEDIA" ) %>
  </TD>
 </TR>
<%
		}
%>
 <TR>
  <TD class=BgShadow nowrap colspan=7 align=right>
   <BR>
   <TABLE border=0 cellpadding=0 cellspacing=0 width="100%"><TR>
    <TD align=left>&nbsp; &nbsp; &nbsp; &nbsp;</TD>
    <TD nowrap align="right">
     &nbsp; &nbsp; &nbsp; &nbsp;
     
     <a href="javascript:doSubmit();">
     <%
     	//Properties params = new Properties(); 
     	//params.setProperty( "onclick", "javascript:doSubmit()");
     	//out.print( JSHelper.getJsLocalizedButton( "BUTTON_FORWARD", "ALT_TEXT_FORWARD", false, params ) );
     	out.print( JSHelper.getJsLocalizedButton( "BUTTON_FORWARD", "ALT_TEXT_FORWARD", false ) );
     %>
     </a>
     &nbsp; &nbsp; &nbsp; &nbsp;
     <a href="<%=parBack%>"><%= JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) %></a>
     &nbsp; &nbsp; &nbsp; &nbsp;
    </TD>
   </TR></TABLE>
   <BR>
  </TD>
 </TR>
 <TR>
  <TD colspan=7 class=FieldBlock></td>
 </tr>
</table>
<%= sbPassForm.toString() %>
</form>

<%
	}
	catch ( IMMessageBoxException imbe ) {
		out.println( imbe.getHtmlMessage( is ) );
		out.println( "</body></html>" );
		return;
	}

%>

</body>
</html>
--%>