<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *    Download user profile for the viewer.
 *
-- %><%@
	page import="java.io.*, java.sql.*,
			com.erad.pacs.services.usermanager.client.Session,
			com.erad.pacs.services.usermanager.tomcat.Sessita,
			imagemed.util.*, imagemed.imsession.*, java.util.*, imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!
	static final File[] CONFIGFILES;
	static final Set<File> NON_PROPERTIES_FILES;
	static {
		List<File> confFiles = new ArrayList<File>();
		NON_PROPERTIES_FILES = new HashSet<File>();
		// add config files here
		String confDir = IMEnvBase.getEnv( "CONF" );
		confFiles.add( new File( confDir + "/nameformat.cfg" ) );
		confFiles.add( new File( confDir + "/dateformat.cfg" ) );
		confFiles.add( new File( confDir + "/timeformat.cfg" ) );
		confFiles.add( new File( confDir + "/fieldNames.rec" ) );
		confFiles.add( new File( confDir + "/gui.conf" ) );
		confFiles.add( new File( confDir + "/institution" ) );
		confFiles.add( new File( confDir + "/fieldValues.rec" ) );
		
		File customVC = new File( IMEnvBase.getEnv( "DICOM_VAR" ) + "/mappings/global/viewer.map" );
		if( customVC.exists() ) {
			confFiles.add( customVC );
			NON_PROPERTIES_FILES.add( customVC );
		}
		
		File f = new File( confDir + "/series_description_keywords.xml" );
		confFiles.add( f );
		NON_PROPERTIES_FILES.add( f );
		
		confFiles.add( new File( confDir + "/speech_recognition.cfg" ) );
		CONFIGFILES = confFiles.toArray( new File[ 0 ] );
	}

	static String toSection( String content ) {
		return "content=" + Helper.replace( Helper.replace( content, "\n", "\\n" ), "\r", "\\r" ) + "\r\n";
	}

	static String toSection( IMProperties props ) {
		StringBuffer result = new StringBuffer( "" );
		Enumeration<?> names = props.keys();
		while ( names.hasMoreElements() ) {
			String name = (String) names.nextElement();
			String value = Helper.replace( Helper.replace( props.getProperty( name ), "\n", "\\n" ), "\r", "\\r" );
			result.append( name + "=" + value + "\r\n" );
		}
		return result.toString();
	}

	static String getServerProfile() {
		StringBuffer result = new StringBuffer( "" );
		for ( int i = 0; i < CONFIGFILES.length; i++ ) {
			if ( !CONFIGFILES[ i ].exists() ) {
				continue;
			}
			result.append( "[server\\" + CONFIGFILES[ i ].getName() + "]\r\n" );
			String content = Helper.readTextFile( CONFIGFILES[ i ].getAbsolutePath() );
			if (!NON_PROPERTIES_FILES.contains( CONFIGFILES[i] )){
				IMProperties contentPrp = new IMProperties();
				contentPrp.recRead( CONFIGFILES[ i ].getAbsolutePath() );
				if ( !contentPrp.isEmpty() ) {
					// seems to be a properties-like configfile
					result.append( toSection( contentPrp ) );
					continue;
				}
			}
			result.append( toSection( content ) );
		}
		
		DicomSrvToolbox.VersionInfo versionInfo = DicomSrvToolbox.getServerVersion();
		if ( versionInfo != null ) {
			result.append( "[Server]\r\n" );
			result.append( "Version=" + versionInfo.getVersionNumber() + "\r\n" );
			result.append( "RevisionNumber=" + versionInfo.getRevisionNumber() + "\r\n" );
			result.append( "Type=" + versionInfo.getServerType().getTypeName() + "\r\n" );
			String cloneDate = versionInfo.getCloneDate();
			if ( cloneDate != null ) {
				result.append( "CloneDate=" + cloneDate +"\r\n" );
			}
		}
		
		return result.toString();
	}

%><%
	Sessita sessita = Sessita.Create( request, response );
	Session sess = sessita.getSession();

	String strProfileData = "";
	String strTrail = "\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n";
	
	String sid = sess.getSessionId();
	if ( sid != null ) {
		Statement st = IMEnv.getDB().createStatement();
		ResultSet rs = st.executeQuery( "SELECT USERID, AGROUP FROM " + IMEnvBase.getEnv( "SESSIONTBL" ) + " natural join " + IMEnvBase.getEnv( "ACCESSTBL" ) +
				" WHERE SID='" +sid+ "'" );
		if ( rs.next() ) {
			String strUserName = rs.getString( "USERID" );
			String strGroupName = rs.getString( "AGROUP" );
			
			//String strProfileDir = IMEnvBase.getEnv("USERS_DATA") + "/" + strUserName;
			//String strProfileFile = IMEnvBase.getEnv("PROFILE_FILE");

			File fProfileFile = new File( IMEnvBase.getEnv( "USERS_DATA" ) + "/" + strUserName + "/" + IMEnvBase.getEnv( "PROFILE_FILE" ) );
			if ( !fProfileFile.exists() && strGroupName != null ) {
				fProfileFile = new File( IMEnvBase.getEnv( "USERS_DATA" ) + "/#" + strGroupName + "/" + IMEnvBase.getEnv( "PROFILE_FILE" ) );
			}

			if ( fProfileFile.exists() ) {
				long lProfileFile = fProfileFile.length();
				byte[] byteProfileBuffer = new byte[ (int) lProfileFile ];
				FileInputStream fInStream = new FileInputStream( fProfileFile );
				fInStream.read( byteProfileBuffer, 0, (int) lProfileFile );
				fInStream.close();

				strProfileData = new String( byteProfileBuffer );

				if ( strProfileData.startsWith( ViewerProfileManager.MODSTRING ) ) {
					strProfileData = strProfileData.substring( ( ViewerProfileManager.MODSTRING ).length() + 1 );
					ViewerProfileManager pm = new ViewerProfileManager( strUserName );
					pm.removeModifiedMark();
					pm.writeProfile();
				}

				if ( strProfileData.indexOf( "\r" ) < 0 ) {
					strProfileData = Helper.replace( strProfileData, "\n", "\r\n" );
				}
			}
		}
		rs.close();
	}

	strProfileData += getServerProfile();
	strProfileData += strTrail;

	response.setContentType( "text/plain" );
	response.setHeader( "Content-length", Long.toString( strProfileData.length() ) );
	response.setHeader( "Pragma", "no-cache" );

	out.println( strProfileData );

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
--%>
