#!/bin/sh
#
# usage processreport <report dump file> [<userid>]
#
#

LOGGER="/usr/bin/logger"
TAG="processreport[$$]"

. $HOME/etc/setenv.sh

File=$1
User=$2

# device can be HTTP:false or HTTP:true
# both comes from iface/importReport.jsp
# HTTP:true means cMerge parameter was received which turns on
# merging received date into first editable report
Device=$3

[ -z "$File" -o ! -f "$File" ] && exit 1

Date=`date +"%Y%m%d%H%M%S"`

ConvFile="$TMP/procreport.$$.$Date"

$DCMTK_HOME/bin/dump2dcm --line 16384 $File $ConvFile >/dev/null 2>/dev/null

[ $? -ne 0 ] && exit 1

[ -n "$User" ] && User=" -u \"$User\""
[ -n "$Device" ] && User=" -d \"$Device\""

PR_COMMAND="$SR_HOME/bin/processreport -f $ConvFile $User $Device"

# $LOGGER -p $LOG_FACILITY.debug -t "$TAG" "$PR_COMMAND"
eval $PR_COMMAND

Res=$?

rm $ConvFile 2>/dev/null

exit $Res
