<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *    Performs daily tasks: purges old studies and orders.
 *
 * Params:
 *   f - pathinfo : looks like <study><fname>_<frame>[.<size>[w|t]].<ext>
 *                  9.8.7.6/CT.1.2.3.4.5_1[.size[w|t]].ext
 * 
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@
	page import="imagemed.dotcom.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*,
			java.util.*, java.io.*, java.sql.*"

%><%
	IMSession is = new IMSession( request, response, out ); 
	Syslog logger = new Syslog( "getsrdump", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
	
/* 	is.bRegNotNeeded &= ProxyToolbox.init(is, request, logger);
 */	
 
	is.bCheckHttpsAndRedirect = false;
	if ( !is.regOK() ) {
		return;
	}

 
	if ( !is.hasRight( imagemed.types.flag.IMTypeur.SUPPORT_RIGHT ) ) {
		response.sendError( 500, "No rights" );
		return;
	}
 
 	if ( "init".equals( request.getParameter( "cOper" ) ) ) {
 		is.out.print( "<div style='width: 100%; text-align: center; font size: larger; font-style: italic; padding: 20px;'>" );
 		is.out.print( LocalizedMessage.getSimpleMessage( "IMADMIN_FER_PREVIEW" ) );
 		is.out.println( "</div>" );
 		return;
 	}
 
 
	String study = request.getParameter( "cStudy" );
	String file = request.getParameter( "cFile" );

	if ( study == null || file == null ) {
		logger.syslog( Syslog.LOG_DEBUG, "Study or File is null" );
		return;
	}

	String workID = request.getParameter( "cWork" );
	String workDirName = IMEnvBase.getEnv( "TMP" ) + "/" + workID;

	// text v. html
	String ruleSet = null;
	try {
		if ( "text".compareToIgnoreCase( request.getParameter( "cRule" ) ) == 0 ) {
			ruleSet = "text";
		}
	}
	catch ( Throwable th ) {
	}

	if ( ruleSet == null ) {
		ruleSet = "html";
	}

	try {
		String studyDirName = RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_DATA_DICOM" ), study );
		if ( studyDirName == null ) {
			response.sendError( 500, "Study was not found in DICOM repository" );
			return;
		}
		if ( ! new File( studyDirName + "/" + file ).exists() ) {
			response.sendError( 500, "Structured report file was not found in study directory " +  studyDirName + "/" + file);
			return;
		}

		String tempFile = IMEnvBase.getEnv( "TMP" ) + "/formattedsr." + System.currentTimeMillis() + "." + Helper.getCounter();
		
		Vector<String> cmd = new Vector<String>();
		cmd.add( IMEnvBase.getEnv( "SR_HOME" ) + "/bin/formatSR" );
		cmd.add( "-v" );
		cmd.add( "-r" );
		cmd.add( ruleSet );
		cmd.add( "-f" );
		cmd.add( studyDirName + "/" + file );
		cmd.add( "-o" );
		cmd.add( tempFile );

		
		String env[] = {
			"SR_FORMAT_DIR=" + workDirName + "/format",
			"SR_HOME=" + IMEnvBase.getEnv( "SR_HOME" )
		};
		
		RunCommandResult res = Helper.runCommandEx( cmd.toArray( new String[ cmd.size() ] ), env );
		
		String details = LocalizedMessage.getSimpleMessage( "IMADMIN_FER_SHOW_OUTPUT" );
		String hideDetails = LocalizedMessage.getSimpleMessage( "IMADMIN_FER_HIDE_OUTPUT" );
		
		boolean isEmpty = true;
		boolean isBody = false;
		boolean isText = "text".equals( ruleSet );

		try ( BufferedReader br = new BufferedReader( new FileReader( tempFile ) ); ) {
			String line = null;
			is.out.println( "<!DOCTYPE html>" );
			while ( null != (line = br.readLine() ) ) {
				if ( isBody ) {
					if ( line.toLowerCase().startsWith( "</body>" ) ) {
						isBody = false;
						if ( isText ) {
							is.out.println( "</pre>" );
						}
					}
					else if ( !"".equals( line.trim() ) ) {
						isEmpty = false;
					}
					
				}
				else if ( line.toLowerCase().startsWith( "</head>" ) ) {
					is.out.println( StyleToolbox.getStylePart( is, "tableStyles" ) );
					JSHelper.printJsInclude( is.out, JSHelper.TABLESCRIPTS_JS );
					out.println( "<script>" );
					out.println( " function toggleOutput() {" );
					out.println( "  var outE = document.getElementById( 'detailsOut' );" );
					out.println( "  var butS = document.getElementById( 'buttonShow' );" );
					out.println( "  var butH = document.getElementById( 'buttonHide' );" );
					out.println( "  if ( outE.style.display === 'none' ) {" );
					out.println( "   butS.style.display = 'none';" );
					out.println( "   butH.style.display = 'inline';" );
					out.println( "   outE.style.display = 'block';" );
					out.println( "  } else {" );
					out.println( "   outE.style.display = 'none';" );
					out.println( "   butS.style.display = 'inline';" );
					out.println( "   butH.style.display = 'none';" );
					out.println( "  }" );
					out.println( " }" );
					out.println( "</script>" );
				}
				else {
					if ( line.toLowerCase().startsWith( "<body>" )) {
						out.println( "<body style='margin: 0px; padding: 0px;'>" );
						isBody = true;

						out.println( "<div style='width: 100%; height: 20px; padding-right: 10px; margin: 5px;'>" );
						out.print( "<span id='buttonShow' style='float: right;' onClick='toggleOutput();'>" );
						out.print( JSHelper.getJsLocalizedButton( "BUTTON_DETAILS", "IMADMIN_FER_SHOW_OUTPUT", false ) );
						out.print( "</span>" );
						out.print( "<span id='buttonHide' style='display: none; float: right;' onClick='toggleOutput();'>" );
						out.print( JSHelper.getJsLocalizedButton( "BUTTON_DETAILS", "IMADMIN_FER_HIDE_OUTPUT", false ) );
						out.print( "</span>" );
						out.println( "</div>" );

						out.println( "<pre id='detailsOut' class='BgShadow' style='width: 90%; height: 250px; padding: 5px; margin: 20px auto; border: 1px; border-style: solid; overflow: auto; display: none;'>" );
						out.print( Helper.htmlEncode( res.getOutput() ) );
						out.println( "</pre>" );

						// body is already printed

						if ( isText ) {
							is.out.println( "<pre>" );
						}

						continue;
					}
				}
				out.println( line );
			}
		}
		catch ( Throwable th ) {
			throw new IOException( "Error reading Structured Report: " + Helper.throwable2String( th ) );
		}

		if ( isEmpty ) {
	 		is.out.print( "<div style='width: 100%; text-align: center; font size: larger; font-style: italic; padding: 20px;'>" );
	 		is.out.print( LocalizedMessage.getSimpleMessage( "IMADMIN_FER_HIDDEN_REPORT" ) );
	 		is.out.println( "</div>" );
	 		return;
		}
		
		new File( tempFile ).delete();
		
	}
	catch ( Throwable th ) {
		throw new IOException( "Error reading Structured Report: " + Helper.throwable2String( th ) );
	}

	if (true) {
		// For avoiding extra newline(s)
		return;
	}
%>
--%>