<%--
 ** Component: imadmin
 **
 ** Description:
 **   Validate dotcom devices, check if the device id is the same on the parent or child
 **
--%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%@
	page import="java.net.*, java.nio.file.*, java.sql.*, java.io.*, java.util.*,
		com.mysql.jdbc.StringUtils, imagemed.util.*, imagemed.imsession.*, imagemed.jsputil.*, 
		imagemed.http.*, imagemed.dotcom.*, imagemed.http.rmi.RMISubstitute, 
		com.erad.pacs.services.usermanager.client.Envelope,
		com.erad.pacs.services.usermanager.client.Session,
		com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
		com.erad.pacs.connector.Connector,
		com.erad.pacs.modules.gwt.descriptors.devices.DeviceType"

%><%-- ----- Input Parameter(s) ----- --%><%
	String parOp = request.getParameter( "op" );
	String parID = request.getParameter( "ID" );
	String parOtherID = request.getParameter( "otherID" );
	String parCallerID = request.getParameter( "caller" );
	String parValidID = request.getParameter("validID");
  
	final String validprefix = "dotcom_validate_";

	boolean acceptUserLogin = parOp == null || ( "Recursive".equals( parOp ) && parCallerID == null );

%><%-- Helper function(s) --%><%!
	
	static final String validateVersion = "V06";

	/** class for the required validation version */
	private static class MinimalVersion {

		/** the oldest acceptable validation version */
		private String minVersion;
		/** custom error message explaining validation version is not acceptable */
		private String oldVersionErrorMsg;

		/** if bMinVersion's value is true then peerversion's value must be bigger than or must be equal with minVersion's value else peerversion's value and minVersion's value must be equal. */
		private Boolean bMinVersion = null;

		private MinimalVersion( String paramMinVersion, String paramOldVersionErrorMsg ) {
			this.minVersion = paramMinVersion;
			this.oldVersionErrorMsg = paramOldVersionErrorMsg;
			setBMinVersion();
		}

		private String getOldVersionErrorMsg( boolean startWithSpace ) {
			if ( oldVersionErrorMsg == null ) {
				return "";
			}
			if ( startWithSpace ) {
				return " " + oldVersionErrorMsg;
			}
			return oldVersionErrorMsg;
		}

		private boolean isMinVersion() {
			if ( bMinVersion == null ) {
				setBMinVersion();
			}
			return bMinVersion;
		}

		private void setBMinVersion() {
			String equalMark = "-equality";
			String minMark = "-min";
			if ( bMinVersion != null ) {
				return;
			}
			if ( minVersion == null || !( minVersion.contains( "-" ) ) ) {
				bMinVersion = true;
				return;
			}

			if ( minVersion.endsWith( equalMark ) ) {
				bMinVersion = false;
				minVersion = minVersion.substring( 0, minVersion.indexOf( equalMark ) );
			}
			else if ( minVersion.endsWith( minMark ) ) {
				bMinVersion = true;
				minVersion = minVersion.substring( 0, minVersion.indexOf( minMark ) );
			}
			else {
				bMinVersion = true;
				minVersion = null;
			}
		}

		private String getMinVersion() {
			if ( minVersion == null ) {
				return "";
			}
			return minVersion;
		}
	}

	/** class for storing device id and device type together */
	private static class DeviceElement {

		/** device id */
		private String devID;
		/** device type */
		private char devType;

		private DeviceElement( String devID, char devType ) {
			this.devID = devID;
			this.devType = devType;
		}
	}

	/**
	 * Returns true if validator version is too old.
	 * 
	 * @param peerVersion	the local server's validator version as String
	 * @param minVersion	the remote server's validator version as MinimalVersion object	
	 * @return true if validator version is too old 
	 */
	boolean isOldValidatorVersion( String peerVersion, MinimalVersion minVersion ) {
		if ( minVersion == null ) {
			return false;
		}
		if ( peerVersion == null || ( peerVersion.length() == 0 ) || ( peerVersion.contains( "?" ) ) ) {
			return true;
		}
		String strMinVersion = minVersion.getMinVersion();
		if ( strMinVersion.length() == 0 ) {
			return false;
		}
		if ( minVersion.isMinVersion() ) {
			return ( peerVersion.compareTo( minVersion.getMinVersion() ) < 0 );
		}
		return !( peerVersion.equals( minVersion.getMinVersion() ) );
	}

	String CheckPeer( String host, String fullPath, boolean bSecure, String postData ) {
		String result = null;
		try {
			String protocol = bSecure ? "https" : "http";
			int port = -1;
			String strPort = bSecure ? IMEnvBase.getEnv( "HTTPS_PORT" ) : IMEnvBase.getEnv( "HTTP_PORT" );
			try {
				port = Integer.parseInt( strPort );
			}
			catch ( Throwable ith ) {
			}
			URL thepage = IMProxy.createURL( protocol, host, port, fullPath );
			HttpURLConnection conn = (HttpURLConnection) IMProxy.openConnection( thepage, postData, null );
			try ( InputStream inStream = conn.getInputStream() ) {
				byte[] buffer = new byte[ 1024 ];
				int nReadBytes = 0;

				while ( ( nReadBytes = inStream.read( buffer ) ) > 0 ) {
					if ( null == result )
						result = new String( buffer, 0, nReadBytes );
					else
						result = result + new String( buffer, 0, nReadBytes );
				}
			}
			conn.disconnect();
		}
		catch ( Throwable th ) {
			result = "<FONT color=red>Connection problem: " + Helper.htmlEncode( th.toString() ) + "</FONT>";
		}

		return result;
	}


	boolean CheckAndDisplayPeer( JspWriter out, String host, String fullPath, boolean bSecure, MinimalVersion minVersion ) throws IOException {
		return CheckAndDisplayPeer( out, host, fullPath, bSecure, null, minVersion );
	}

	boolean checkAndDisplayResult( String result, JspWriter out, String host, MinimalVersion minVersion ) throws IOException {
		boolean rOk = ( result.indexOf( "color=red" ) == -1 );
		
		if( !rOk ) {
			// we don't check the validate version in case of more serious problems (like connection)
			out.println(result);
			return rOk;
		}

		int pos = result.indexOf( "<!-- Validate Version: " );
		boolean isMinVersionNull = ( minVersion == null );

		if ( pos == -1 ) {
			out.println( "<FONT color=red><I>" + host + "</I> has old validate version." + ( ( !isMinVersionNull ) ? minVersion.getOldVersionErrorMsg( true ) : "" ) + "</FONT><BR>" );
			if ( !isMinVersionNull ) {
				return false;
			}
		}
		else {
			if ( result.indexOf( "<!-- Validate Version: " + validateVersion + " -->" ) == -1 ) {
				String peerVersion = "???";
				try {
					peerVersion = result.substring( pos + 23, pos + 26 );
				}
				catch ( Throwable th ) {
				}
				StringBuffer sbErrorMessage = new StringBuffer();
				if ( isOldValidatorVersion( peerVersion, minVersion ) ) {
					if ( minVersion.isMinVersion() ) {
						sbErrorMessage.append( "The " ).append( peerVersion ).append( " validate version is too old at <I>" );
						sbErrorMessage.append( host ).append( "</I>.<BR>( Minimal validate version: " ).append( minVersion.getMinVersion() );
						sbErrorMessage.append( " )." );
					}
					else {
						sbErrorMessage.append( "( The equality is required. )" );
					}
					String strCustomOldVersionErrorMsg = minVersion.getOldVersionErrorMsg( false );
					if ( strCustomOldVersionErrorMsg.length() != 0 ) {
						sbErrorMessage.append( "<BR>" ).append( strCustomOldVersionErrorMsg );
					}
				}
				out.println( "<FONT color=red>Validate version mismatch at <I>" + host + "</I>: " +
						validateVersion + " &lt; - &gt; " + peerVersion + ". " + ( ( sbErrorMessage.length() != 0 ) ? sbErrorMessage.toString() : "" ) + "</FONT><BR>" );
				if ( sbErrorMessage.length() != 0 ) {
					return false;
				}
			}
		}
		out.println( result );
		return rOk;
	}

	boolean CheckAndDisplayPeer( JspWriter out, String host, String fullPath, boolean bSecure, String postData, MinimalVersion minVersion ) throws IOException {
		String result = CheckPeer( host, fullPath, bSecure, postData );
		return checkAndDisplayResult( result, out, host, minVersion );
	}

	int getPatchVersion() {
		int patchVersion = 0;
		String cmd[] = new String[ 2 ];

		cmd[ 0 ] = IMEnvBase.getEnv( "TOOLS_HOME" ) + "/applyupdates.sh";
		cmd[ 1 ] = "-Q";
		Helper.DEBUG( "Validate", "Exec Command: " + cmd[ 0 ] + " " + cmd[ 1 ] );

		try {
			Process p = Runtime.getRuntime().exec( cmd, null );
			String info = "";
			try ( InputStream isOut = p.getInputStream() ) {
				int ex = p.waitFor();
				Helper.DEBUG( "Validate", "Command result: " + ex );
				byte[] buff = new byte[ 1024 ];
				int r = 0;
				while ( -1 != ( r = isOut.read( buff ) ) ) {
					String str = new String( buff, 0, r );
					info = info + str;
				}
			}
			p.destroy();
			Helper.DEBUG( "Validate", "Info: " + info );

			StringTokenizer infost = new StringTokenizer( info, "\n\r=" );
			while ( infost.hasMoreTokens() ) {
				String act = infost.nextToken();
				if ( act.equals( "serverPatch" ) ) {
					if ( infost.hasMoreTokens() ) {
						act = infost.nextToken();
						String med = "medley-";
						int medstart = act.indexOf( med );
						String patchVersionStr = "";
						if ( medstart != -1 ) {
							patchVersionStr = act.substring( medstart + med.length() );
							try {
								patchVersion = Integer.parseInt( patchVersionStr );
							}
							catch ( Throwable th ) {
							}
						}
					}
				}
			}
		}
		catch ( Throwable th ) {
			Helper.DEBUG( "Validate", "Exception in getPatchVersion: " + th.toString() );
		}

		return ( patchVersion );
	}

	String getDatabaseConcept() {
		StringBuffer res = new StringBuffer();

		for ( int i = 0; i < DotcomToolbox.m_tables.length; i++ ) {
			String table = DotcomToolbox.m_tables[ i ];

			/*			
						List<String> cmd = new ArrayList<String>();
						cmd.add( IMEnvBase.getEnv( "TOOLS_HOME" ) + "/sql.sh" );
						cmd.add( "\"select TABLE_NAME, COLUMN_NAME, COLUMN_TYPE, COLUMN_DEFAULT from INFORMATION_SCHEMA.COLUMNS where TABLE_NAME='" + table + "' ORDER BY COLUMN_NAME\"");
						cmd.add( "-N" );
					
						Helper.DEBUG( "Database concept command:" + cmd.toString() );
						
						RunCommandResult comResult = Helper.runCommandEx( cmd.toArray( new String[ 0 ] ) );
						if( comResult.getExitCode() != 0 ) {
							Helper.ERRORLOG( "ERROR:" + comResult.getError() );
							return( "ERROR:" + comResult.getError() );
						}
					
						res.append( comResult.getOutput().trim() );
			*/

			String excludedcols = "'DcobjectID'"; //,masik, harmadik
			if ( IMEnvBase.getEnv( "OBJECTTBL" ).equals( table ) ) {
				excludedcols += ",'ID'";
			}

			String query = "select TABLE_NAME, COLUMN_NAME, COLUMN_TYPE, COLUMN_DEFAULT from INFORMATION_SCHEMA.COLUMNS where TABLE_NAME='" + table + "' AND COLUMN_NAME NOT IN(" + excludedcols + ") ORDER BY COLUMN_NAME";
			try ( Statement sql = IMEnv.getDB().createStatement() ) {
				ResultSet rs = sql.executeQuery( query );
				while ( rs.next() ) {
					String tableName = rs.getString( "TABLE_NAME" );
					if ( tableName != null ) {
						res.append( "\t" ).append( tableName );
					}
					String colName = rs.getString( "COLUMN_NAME" );
					if ( colName != null ) {
						res.append( "\t" ).append( colName );
					}
					String colType = rs.getString( "COLUMN_TYPE" );
					if ( colType != null ) {
						res.append( "\t" ).append( colType );
					}
					String colDef = rs.getString( "COLUMN_DEFAULT" );
					if ( colDef != null ) {
						res.append( "\t" ).append( colDef );
					}
				}
			}
			catch ( Throwable th ) {
				Helper.ERRORLOG( "SQL Exception:" + Helper.throwable2String( th ) );
				return "ERROR:" + Helper.throwable2String( th );
			}
		}
		//we don't check the indices, it can be configured differently

		return res.toString().trim();
	}

	String getTimeZone( String deviceID ) {
		DeviceConfig devCfg = new DeviceConfig( deviceID );
		String strTimeZone = devCfg.getTimeZone();
		if ( strTimeZone.equals( "Default" ) ) {
			strTimeZone = TimeZone.getDefault().getID();
		}
		return strTimeZone;
	}
%><!-- Validate Version: <%= validateVersion %> -->
<%
	String selfID = DotcomConfig.staticReadSelfID();

	// Peer request for checking license
	if ( parOp != null && parOp.equals( "checkLicense" ) ) {
		try {
			TabBean.checkLicense( true );
		}
		catch ( Exception e ) {
			out.println( "<FONT color=red> License validation failed. <BR> Reason: " + Helper.throwable2String( e ) + "</font>" );
			return;
		}
		out.println( "<span class=FontOK>OK</span>" );
		return;
	}

	// Peer request for checking if peer is our parent
	if ( parOp != null && parOp.equals( "amIParent" ) ) {
		try {
		Properties prp = DotcomToolbox.checkIPAddress( request.getRemoteAddr(), "P" );
		if ( prp != null ) {
			if ( !parID.equals( prp.getProperty( "ID" ) ) ) {
				out.println( "<FONT color=red>On this remote server your device id (" + prp.getProperty( "ID" ) +
						") differs from your configuration (" + parID + ")</FONT>" );
			}
			else {
				out.println( "<span class=FontOK>OK</span>" );
			}
		}
		else {
			out.println( "<FONT color=red>on this remote server you seem to be connecting from " + request.getRemoteAddr() +
					" but there is no such Parent server configured</FONT>" );
		}
		}
		catch (Throwable th) {
			out.println( "<FONT color=red>this remote server threw the following exception: <br><pre>" + Helper.toString(th)+"</pre></FONT>" );
		}
		return;
	}

	// Peer request for checking if peer is our child
	if ( parOp != null && parOp.equals( "amIChild" ) ) {
		try {
		Properties prp = DotcomToolbox.checkIPAddress( request.getRemoteAddr(), "C" );
		if ( prp != null ) {
			if ( !parID.equals( prp.getProperty( "ID" ) ) ) {
				out.println( "<FONT color=red>On this remote server your device id (" + prp.getProperty( "ID" ) +
						") differs from your configuration (" + parID + ")</FONT>" );
			}
			else {
				out.println( "<span class=FontOK>OK</span>" );
			}
		}
		else {
			out.println( "<FONT color=red>on this remote server you seem to be connecting from " + request.getRemoteAddr() +
					" but there is no such Child server configured</FONT>" );
		}
		}
		catch (Throwable th) {
			out.println( "<FONT color=red>this remote server threw the following exception: <br><pre>" + Helper.toString(th)+"</pre></FONT>" );
		}
		return;
	}

	String strAmIBackupTarget = "amI" + DeviceType.BACKUP_TARGET.name();
	String strAmIBackupSource = "amI" + DeviceType.BACKUP_SOURCE.name();
	
	if ( (parOp != null) && (parOp.equals(strAmIBackupTarget) || parOp.equals(strAmIBackupSource)) ) {
		DeviceType devType = DeviceType.BACKUP_SOURCE;
		if ( parOp.equals( strAmIBackupTarget ) ) {
			devType = DeviceType.BACKUP_TARGET;
		}
		try {
		Properties prp = DotcomToolbox.checkIPAddress( request.getRemoteAddr(), "" + devType.getCodeStr() );
		if ( prp != null ) {
			if ( !parID.equals( prp.getProperty( "ID" ) ) ) {
				out.println( "<FONT color=red>On this remote server your device id (" + prp.getProperty( "ID" ) +
						") differs from your configuration (" + parID + ")</FONT>" );
			}
			else {
				out.println( "<span class=FontOK>OK</span>" );
			}
		}
		else {
			out.println( "<FONT color=red>on this remote server you seem to be connecting from " + request.getRemoteAddr() +
					" but there is no such " + devType.getLabel() + " server configured</FONT>" );
		}
		}
		catch (Throwable th) {
			out.println( "<FONT color=red>this remote server threw the following exception: <br><pre>" + Helper.toString(th)+"</pre></FONT>" );
		}
		return;
	}

	// Peer request for checking if peer is ourself (validates IP settings)
	if ( parOp != null && parOp.equals( "amIMe" ) ) {
		if ( !request.getRemoteAddr().equals( IMEnvBase.getEnv( "SERVERIP" ) ) ) {
			out.println( "<FONT color=red>Your local IP mismatches (" + request.getRemoteAddr() + " - " +
					IMEnvBase.getEnv( "SERVERIP" ) + ")</FONT>" );
		}
		else {
			if ( !parID.equals( DotcomConfig.selfId() ) ) {
				out.println( "<FONT color=red>Your local IP/name points to a different server (" + DotcomConfig.selfId() +
						") instead of (" + parID + ")</FONT>" );
			}
			else
				out.println( "<span class=FontOK>OK</span>" );
		}
		return;
	}

	// Peer request for checking clock settings
	if ( parOp != null && parOp.equals( "checkClock" ) ) {
		GregorianCalendar c = new GregorianCalendar();
		long time = Long.parseLong( parID );
		long diff = c.getTimeInMillis() - time;
		if ( diff < -60000 || diff > 60000 ) {
			out.println( "<FONT color=red>Time mismatch is more than a minute</FONT>" );
		}
		else {
			out.println( "<span class=FontOK>OK</span>" );
		}
		return;
	}


	// Peer request for checking server patch version
	if ( parOp != null && parOp.equals( "checkPatch" ) ) {
		int patchVersion = getPatchVersion();
		int otherPatchVersion = 0;
		try {
			otherPatchVersion = Integer.parseInt( parID );
		}
		catch ( Throwable ith ) {
		}
		if ( parID == null ) {
			out.println( "<FONT color=red>Server Patch Version Parameter is null</FONT>" );
		}
		else if ( patchVersion != otherPatchVersion ) {
			out.println( "<FONT color=red>Server Patch Version mismatch" );
			if ( parOtherID != null ) {
				out.println( "'" + selfID + "': " + patchVersion + ", '" + parOtherID + "': " + otherPatchVersion + "</FONT><BR>" );
			}
			else {
				out.println( "</FONT><BR>" );
			}
		}
		else {
			out.println( "<span class=FontOK>OK</span>" );
		}
		return;
	}

	// Peer request for checking database concept
	if ( parOp != null && parOp.equals( "checkDatabase" ) ) {
		String methodChangerVersion = "V06";
		String parValidateVersion = request.getParameter( "valVersion" );
		String parDiffTableFields = request.getParameter( "tFieldDiff" );
		boolean bLegacyCheck = true;

		if ( ( parDiffTableFields != null ) && ( parDiffTableFields.length() > 0 ) ) {
			bLegacyCheck = false;
		}
		else if ( ( parValidateVersion != null ) && ( parValidateVersion.length() > 0 ) ) {
			bLegacyCheck = ( validateVersion.compareTo( methodChangerVersion ) < 0 );
		}

		String parDatabase = request.getParameter( "database" );
		if ( bLegacyCheck ) {
			String database = getDatabaseConcept();

			if ( parDatabase == null ) {
				out.println( "<FONT color=red>Database parameter is null</FONT>" );
				return;
			}
			else if ( parDatabase.startsWith( "ERROR" ) ) {
				out.println( "<FONT color=red>Error retrieving other database concept:" + parDatabase + "</FONT>" );
				return;
			}
			else {
				parDatabase = parDatabase.trim();
			}
			if ( database == null ) {
				out.println( "<FONT color=red>Couldn't get database structure</FONT>" );
			}
			else if ( database.startsWith( "ERROR" ) ) {
				out.println( "<FONT color=red>Error retrieving database concept:" + database + "</FONT>" );
				return;
			}
			else {
				int difpos = Helper.compareFindFirstDifference( database, parDatabase );
				if ( difpos != -1 ) {
					out.println( "<FONT color=red>Server Database Structure mismatch</FONT><BR>" );
					int start = Math.max( difpos - 100, 0 );
					out.print( "'" + selfID + "': " + ( start == 0 ? "" : "... " ) + database.substring( start, difpos ) + "<FONT color=red>" );
					if ( database.length() >= difpos + 1 ) {
						int end = Math.min( difpos + 100, database.length() );
						out.print( database.substring( difpos, end ) + ( end == database.length() ? "" : " ..." ) );
					}
					out.print( "</FONT><br><br>" );
					if ( parID != null ) {
						out.print( "'" + parID + "': " + ( start == 0 ? "" : "... " ) + parDatabase.substring( start, difpos ) + "<FONT color=red>" );
						if ( parDatabase.length() >= difpos + 1 ) {
							int end = Math.min( difpos + 100, parDatabase.length() );
							out.print( parDatabase.substring( difpos, end ) + ( end == parDatabase.length() ? "" : " ..." ) );
						}
						out.print( "</FONT><br><br>" );
					}
				}
				else {
					out.println( "<span class=FontOK>OK</span>" );
				}
			}
			return;
		}
		try ( Statement sql = IMEnv.getDB().createStatement() ) {
			String thisPage = request.getServletPath();
			String diffErrorMessageHeader = "<FONT color=red>Server Database Structure mismatch</FONT>";
			String okMessage = "<span class=FontOK>OK</span>";

			if ( ( parDiffTableFields != null ) && ( parDiffTableFields.length() > 0 ) ) {
				String strQueryFixPart = "SELECT TABLENAME FROM Dctables AS tables INNER JOIN Dcfields AS fields ON tables.COLID=fields.COLID WHERE ";
				String[] tableWithFieldsArray = parDiffTableFields.split( ";" );
				StringBuilder sbIncorrectFields = new StringBuilder();
				Boolean firstHit = null;

				if ( tableWithFieldsArray == null ) {
					return;
				}
				for ( String strTableWithFields : tableWithFieldsArray ) {
					String tableName;
					String strTableFields;
					String[] tableFieldsArray;
					int index = -1;

					if ( firstHit != null ) {
						firstHit = true;
					}

					if ( strTableWithFields != null ) {
						index = ( strTableWithFields.indexOf( "-" ) );
					}
					if ( ( strTableWithFields == null ) || ( index == -1 ) || ( ( index + 1 ) >= strTableWithFields.length() ) ) {
						continue;
					}
					tableName = strTableWithFields.substring( 0, index );

					strTableFields = strTableWithFields.substring( index + 1 );
					tableFieldsArray = strTableFields.split( "," );
					for ( String tableField : tableFieldsArray ) {
						if ( ( tableField == null ) || ( tableField.length() == 0 ) ) {
							continue;
						}
						String strQueryChangingPart = "fields.DBNAME='" + tableField + "' AND tables.TABLENAME='" + tableName + "'";
						String strCheckTableName = null;
						try {
							ResultSet rs = sql.executeQuery( strQueryFixPart + strQueryChangingPart );
							if ( rs.next() ) {
								strCheckTableName = rs.getString( "TABLENAME" );
							}
						}
						catch ( Throwable t ) {
						}

						if ( ( strCheckTableName != null ) && strCheckTableName.equals( tableName ) ) {
							if ( firstHit == null ) {
								out.println( diffErrorMessageHeader + "<BR>" );
								out.println( "<FONT color=red>'" + selfID + "' has field(s) which field(s) is/are not in '" + parID + "'</FONT><BR>" );
								firstHit = true;
							}
							if ( firstHit ) {
								sbIncorrectFields.append( tableName + ":<br>\n" );
								firstHit = false;
							}
							else {
								sbIncorrectFields.append( ", " );
							}
							sbIncorrectFields.append( tableField );
						}
					}
					if ( ( firstHit != null ) && ( !firstHit ) ) {
						sbIncorrectFields.append( "<br>" );
					}
				}
				out.println( sbIncorrectFields.toString() );
			}
			else {
				String strQuery = "SELECT HOST, PROTOCOL FROM " + IMEnvBase.getEnv( "TARGETTBL" ) + " WHERE ID='" + parID + "'";
				String host = null;
				try {
					ResultSet rs = sql.executeQuery( strQuery );
					if ( rs.next() ) {
						host = rs.getString( "HOST" );
					}
				}
				catch ( Throwable t ) {
				}

				DatabaseConceptDifference dbDiff = new DatabaseConceptDifference( parDatabase, selfID, parID );
				String strTableFieldsDifferences = dbDiff.getTableFieldsDifferences();

				String strTableDiffErrMessage = dbDiff.getTableDifferenceErrorMessageInHtml();
				if ( strTableDiffErrMessage == null ) {
					strTableDiffErrMessage = "";
				}
				else {
					strTableDiffErrMessage = strTableDiffErrMessage.trim();
				}

				if ( ( strTableFieldsDifferences != null ) && ( strTableFieldsDifferences.length() != 0 ) ) {
					if ( host != null ) {
						CheckAndDisplayPeer( out, host, thisPage + "?op=checkDatabase&ID=" + selfID, true, "tFieldDiff=" + strTableFieldsDifferences, null );
					}
				}
				else {
					if ( !( strTableDiffErrMessage.startsWith( okMessage ) ) ) {
						out.println( diffErrorMessageHeader + "<BR>" );
					}
				}
				if ( !( strTableDiffErrMessage.startsWith( okMessage ) ) ) {
					out.println( "<FONT color=red>The database's fields first structural difference:</FONT><BR>" );
					out.println( strTableDiffErrMessage );
				}
				else {
					out.println( "<span class=FontOK>OK. No structural differences between the database's fields.</span>" );
				}
			}
		}
		return;
	}

	if ( parOp != null && parOp.equals( "checkTimeZone" ) ) {
		String parTimeZone = parID;
		String serverTimezone = TimeZone.getDefault().getID();
		if ( parTimeZone == null ) {
			out.println( "<FONT color=red>Timezone parameter is null</FONT><BR><BR>" );
		}
		else if ( !( parTimeZone.equals( serverTimezone ) ) ) {
			out.println( "<FONT color=red>Timezone mismatch " + ( ( serverTimezone == null ) ? "null" : serverTimezone ) + ", " + parTimeZone + "</FONT><BR><BR>" );
		}
		else {
			out.println( "<span class=FontOK>OK</span><BR><BR>" );
		}
		return;
	}

	
/*****************************************************************	
  Without Operation Starts here
*****************************************************************/

	boolean isRecursive = (parOp != null && parOp.equals("Recursive"));
	boolean isOK = true;

	Session sess = null;


	Properties peerPrp = null;
	try {
		peerPrp = DotcomToolbox.checkClient( null, request.getRemoteAddr(), "PCBS", false );
	}
	catch ( Throwable th ) {
	}

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	if ( peerPrp == null ) {
		if ( !acceptUserLogin ) {
			out.println( "<FONT color=red>Validate request was received from unrecognized/unauthorized address.</FONT><BR>" );
			return;
		}
		sess = userManager.getSessitaSession( request, response );
	}
	else {
		Envelope envelope = Connector.getInstance().get( UserManagerFacade.Caller ).loginService( peerPrp.getProperty( "ID" ) );
		sess = userManager.checkForRmiSubstitute( envelope );
	}

	if ( !isRecursive ) {
%>
<%@page import="imagemed.http.tabs.TabBean"%>
<HEAD>
<TITLE>Server Validation</TITLE>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly( new PrintWriter( out ) );
%>
</HEAD>
<BODY>
	<%
	}

	out.println( "<H2>Validation Status for server <I>'" + selfID + "'</I></H2>" );

	Helper.DEBUG( "validid:" + parValidID );
		
	if( parValidID != null ) {
		// if null, it's a non-recursive call
		// at the first recursive call (itself), it will be non-null
		String vFileName = IMEnvBase.getEnv( "TMP" ) + "/" + validprefix + parValidID + ".txt";
		if( new File( vFileName ).exists() ) {
			// we were here before, it's a loop!	
			String prevCaller = Helper.readTextFile( vFileName );
			out.println( "<BR><FONT color=red>Loop detected involving this server! (Caller is: '" + parCallerID + "'" +
				( prevCaller.length() == 0 ? "" : ", Previous caller is: '" + prevCaller + "'" ) + ")</FONT><BR><BR>" );
			return;
		}
		else {
			Helper.writeTextFile( vFileName, parCallerID == null ? "" : parCallerID );
		}
	}

	Vector<String> vPeers = new Vector<String>();
	Vector<DeviceElement> vDevices = new Vector<DeviceElement>();
	String thisPage = request.getServletPath();
	String trgTbl = IMEnvBase.getEnv( "TARGETTBL" );
	String fullPath = thisPage;
	Connection imDB = IMEnv.getDB();
	Statement sql = imDB.createStatement();
	int patchVersion = getPatchVersion();
	String databaseConcept = DatabaseConceptDifference.getDatabaseConcept();
	MinimalVersion equalsToVersion = new MinimalVersion( validateVersion + "-equality", "Validator versions are not equal." );
	MinimalVersion timeZoneMinVersion = new MinimalVersion( "V06", "Validator version not supports time zone check." );

	boolean hasParent = false;
	try ( ResultSet rs = sql.executeQuery( "SELECT ID, HOST, PROTOCOL FROM " + trgTbl + " WHERE TYPE='P'" ) ) {
		// Testing parent server
		if ( rs.next() ) {
			hasParent = true;
			String devID = rs.getString( "ID" );
			String host = rs.getString( "HOST" );
			String protocol = rs.getString( "PROTOCOL" );
			vPeers.add( host );
			vDevices.add( new DeviceElement( devID, 'P' ) );

			boolean isSecureOnly = "S".equals( protocol );

			String timezoneID = getTimeZone( devID );
	%>Testing HTTP connection to Parent '<%=devID%>'
	<BR>
	<%
			if ( isSecureOnly ) {
				out.println( "<span class=\"FontDisabled\">SECURE-ONLY: SKIPPED</span>" );
			}
			else {
				isOK &= CheckAndDisplayPeer( out, host, fullPath + "?op=amIChild&ID=" + selfID, false, equalsToVersion );
			}
			if( isOK ) {
	%><BR> Testing HTTPS connection to Parent '<%=devID%>'
	<BR>
	<%
				isOK &= CheckAndDisplayPeer( out, host, fullPath + "?op=amIChild&ID=" + selfID, true, equalsToVersion );
	%><BR> Testing license on Parent '<%=devID%>'
	<BR>
	<%
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkLicense", true, null );
	%><BR> Testing time consistency to Parent '<%=devID%>'
	<BR>
	<%
				GregorianCalendar c = new GregorianCalendar();
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkClock&ID=" + c.getTimeInMillis(), true, null );
	%><BR> Testing patch version consistency to Parent '<%=devID%>'
	<BR>
	<%
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkPatch&ID=" + patchVersion + "&otherID=" + selfID, true, null );
	%><BR> Testing database structure on Parent '<%=devID%>'
	<BR>
	<%
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkDatabase&ID=" + selfID, true, "database=" + databaseConcept + "&valVersion=" + validateVersion, null );
	%><BR> Testing timezone consistency to Parent '<%=devID%>'
	<BR>
	<%
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkTimeZone&ID=" + timezoneID, true, timeZoneMinVersion );
			}
	%><BR>
	<%
		}
		if ( rs.next() ) {
	%><FONT color=red>Multiple Parent servers configured</FONT>
	<BR>
	<%
		}
	}

	// Testing child servers
	try ( ResultSet rs = sql.executeQuery( "SELECT ID, HOST, PROTOCOL FROM " + trgTbl + " WHERE TYPE='C'" ) ) {
		while ( rs.next() ) {
			String devID = rs.getString( "ID" );
			String host = rs.getString( "HOST" );
			String protocol = rs.getString( "PROTOCOL" );
			vPeers.add( host );
			vDevices.add( new DeviceElement( devID, 'C' ) );

			boolean isSecureOnly = "S".equals( protocol );

			String timezoneID = getTimeZone( devID );
	%>Testing HTTP connection to Child '<%=devID%>'
	<BR>
	<%
			if ( isSecureOnly ) {
				out.println( "<span class=\"FontDisabled\">SECURE-ONLY: SKIPPED</span>" );
			}
			else {
				isOK &= CheckAndDisplayPeer( out, host, fullPath + "?op=amIParent&ID=" + selfID, false, equalsToVersion );
			}
			if( isOK ) {
	%><BR> Testing HTTPS connection to Child '<%=devID%>'
	<BR>
	<%
				isOK &= CheckAndDisplayPeer( out, host, fullPath + "?op=amIParent&ID=" + selfID, true, equalsToVersion );
	%><BR> Testing license on Child '<%=devID%>'
	<BR>
	<%
				isOK &= CheckAndDisplayPeer( out, host, fullPath + "?op=checkLicense", true, null );
	%><BR> Testing time consistency to Child '<%=devID%>'
	<BR>
	<%
				GregorianCalendar c = new GregorianCalendar();
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkClock&ID=" + c.getTimeInMillis(), true, null );
	%><BR> Testing patch version consistency to Child '<%=devID%>'
	<BR>
	<%
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkPatch&ID=" + patchVersion + "&otherID=" + selfID, true, null );
	%><BR> Testing database structure to Child '<%=devID%>'
	<BR>
	<%
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkDatabase&ID=" + selfID, true, "database=" + databaseConcept + "&valVersion=" + validateVersion, null );
	%><BR> Testing timezone consistency to Child '<%=devID%>'
	<BR>
	<%
				CheckAndDisplayPeer( out, host, fullPath + "?op=checkTimeZone&ID=" + timezoneID, true, timeZoneMinVersion );
			}
	%><BR>
	<%
		}
	}

		// Testing Backup Target servers
		DeviceType[] backupDeviceTypes = { DeviceType.BACKUP_TARGET, DeviceType.BACKUP_SOURCE };
		for( DeviceType dt : backupDeviceTypes ) {
			try(ResultSet rs = sql.executeQuery("SELECT ID, HOST, PROTOCOL FROM " + trgTbl + " WHERE TYPE='" + dt.getCodeStr() +"'")){
				String strOp = "amI" + RMISubstitute.getInvertedDeviceType( dt ).name();

				if ( rs.next() ) {
					String devID = rs.getString( "ID" );
					String host = rs.getString( "HOST" );
					String protocol = rs.getString( "PROTOCOL" );
					vPeers.add( host );
					vDevices.add( new DeviceElement( devID, dt.getCode() ) );

					boolean isSecureOnly = "S".equals( protocol );

					String timezoneID = getTimeZone( devID );
	%>Testing HTTP connection to
	<%=dt.getLabel()%>
	'<%=devID%>'
	<BR>
	<%
		if ( isSecureOnly ) {
						out.println( "<span class=\"FontDisabled\">SECURE-ONLY: SKIPPED</span>" );
					}
					else {
						isOK &= CheckAndDisplayPeer( out, host, fullPath + "?op=" + strOp + "&ID=" + selfID, false, equalsToVersion );
					}
	%><BR> Testing HTTPS connection to
	<%=dt.getLabel()%>
	'<%=devID%>'
	<BR>
	<%
		isOK &= CheckAndDisplayPeer( out, host, fullPath + "?op=" + strOp + "&ID=" + selfID, true, equalsToVersion );
					if ( isOK ) {
	%><BR> Testing license on
	<%=dt.getLabel()%>
	'<%=devID%>'
	<BR>
	<%
		CheckAndDisplayPeer( out, host, fullPath + "?op=checkLicense", true, null );
	%><BR> Testing time consistency to
	<%=dt.getLabel()%>
	'<%=devID%>'
	<BR>
	<%
		GregorianCalendar c = new GregorianCalendar();
						CheckAndDisplayPeer( out, host, fullPath + "?op=checkClock&ID=" + c.getTimeInMillis(), true, null );
	%><BR> Testing patch version consistency to
	<%=dt.getLabel()%>
	'<%=devID%>'
	<BR>
	<%
		CheckAndDisplayPeer( out, host, fullPath + "?op=checkPatch&ID=" + patchVersion + "&otherID=" + selfID, true, null );
	%><BR> Testing database structure on
	<%=dt.getLabel()%>
	'<%=devID%>'
	<BR>
	<%
		CheckAndDisplayPeer( out, host, fullPath + "?op=checkDatabase&ID=" + selfID, true, "database=" + databaseConcept + "&valVersion=" + validateVersion, null );
	%><BR> Testing timezone consistency to
	<%=dt.getLabel()%>
	'<%=devID%>'
	<BR>
	<%
		CheckAndDisplayPeer( out, host, fullPath + "?op=checkTimeZone&ID=" + timezoneID, true, timeZoneMinVersion );
					}
	%><BR>
	<%
		}
				if ( rs.next() ) {
	%><FONT color=red>Multiple <%=dt.getLabel()%> servers configured
	</FONT>
	<BR>
	<%
		}
			}
		}

		Map<String, RemoteDeviceHttpTask> threadMap = new HashMap<String, RemoteDeviceHttpTask>();
		if ( isRecursive ) {
			// start threads for the other peers (parent + children, backup source + backup target)
			for ( DeviceElement element : vDevices ) {
				String devID = element.devID;
				if ( devID != null && !"".equals( devID ) && !devID.equals( parCallerID ) ) {
					RemoteDeviceHttpTask remoteTask = new RemoteDeviceHttpTask( devID, fullPath + "?op=Recursive&caller=" + selfID + "&validID=" + parValidID, null, null, element.devType );
					threadMap.put( devID, remoteTask );
					remoteTask.start();

					Helper.DEBUG( "RemoteHttpTask started for:" + devID );
				}
				//				CheckAndDisplayPeer(out, host, fullPath+"?op=Recursive", true);
			}
		}


		// Testing self
	%>Testing HTTP connection to self
	<BR>
	<%
		isOK &= CheckAndDisplayPeer( out, IMEnvBase.getEnv( "SERVERIP" ), fullPath + "?op=amIMe&ID=" + selfID, false, null );
	%><BR> Testing HTTPS connection to self
	<BR>
	<%
		isOK &= CheckAndDisplayPeer( out, IMEnvBase.getEnv( "SERVERIP" ), fullPath + "?op=amIMe&ID=" + selfID, true, null );
	%><BR> Testing HTTP connection to self using HOSTNAME
	<BR>
	<%
		isOK &= CheckAndDisplayPeer( out, IMEnvBase.getEnv( "SERVERNAME" ), fullPath + "?op=amIMe&ID=" + selfID, true, null );
	%><BR> Testing server license on self
	<BR>
	<%
		isOK &= CheckAndDisplayPeer( out, IMEnvBase.getEnv( "SERVERIP" ), fullPath + "?op=checkLicense", true, null );

	
//testing serverids only on topmost device - own traversal, without using dotcomconfig! 
//testing CWL hierarchy only on the topmost device - it makes an own traversal
//these 2 might be 1 BUT the second one uses dotcomconfig!
	if( !hasParent ) {
	%><BR><BR>
	Testing Server IDs in dotcom<BR><%
		PreValidateTraversal ptr = new PreValidateTraversal();
		String result = ptr.doAndCall( sess );
		Helper.DEBUG( "serverids result:" + result );
		boolean isProblem = false;
		Set<String> ids = new HashSet<String>();
		StringTokenizer lines = new StringTokenizer( result, "\n" );
		while ( lines.hasMoreElements() ) {
			String line = lines.nextToken();
			if( line.startsWith( "Serverid:" ) ) {
				String id = line.substring( 9 );
				if( ids.contains( id ) ) {
					out.println( "<FONT color=red>Found the same server ID multiple times in the dotcom:'" + id + "'</FONT><BR>" );
					isProblem = true;
				}
				else {
					ids.add( id );
				}
			}
		}
		if( !isProblem ) {
			out.println( "<span class=FontOK>OK</span>" );
		}
		isOK &= !isProblem;
		
		if( !isProblem ) {
			// if server ids are not unique, we don't check misc cwl thing using dotcomconfig, because it may fall into infinite loop
	%><BR>
	Testing CWL servers in dotcom<BR><%
			ValidateTraversal tr = new ValidateTraversal();
			result = tr.doAndCall( sess );
			lines = new StringTokenizer( result, "\n" );
			isProblem = false;
			boolean isWarning = false;
			while ( lines.hasMoreElements() ) {
				String line = lines.nextToken();
				if( line.startsWith( "Problem" ) ) {
					out.println( "<FONT color=red>" + line + "</FONT><BR>" );
					isProblem = true;
				}
				else if( line.startsWith( "Warning" ) ) {
					out.println( "<FONT color=brown>" + line + "</FONT><BR>" );
					isWarning = true;
				}
			}
			if( !isProblem && !isWarning ) {
				out.println( "<span class=FontOK>OK</span>" );
			}
			
			isOK &= !isProblem; 
		}
	%><BR><BR><%
	}
	
	
		if ( isRecursive ) {
			// wait for the remote tasks to finish
			for ( DeviceElement element : vDevices ) {
				String devID = element.devID;
				if ( devID != null && !"".equals( devID ) && !devID.equals( parCallerID ) ) {
					RemoteDeviceHttpTask remoteTask = threadMap.get( devID );
					if ( remoteTask != null ) {
						Helper.DEBUG( "RemoteHttpTask waiting for:" + devID );
						try {
							remoteTask.join();
							Helper.DEBUG( "RemoteHttpTask ended for:" + devID );
							String newResultStr = remoteTask.getResult();
							MinimalVersion minVersion = null;
							DeviceType remoteType = DeviceType.getByCodeStr( String.valueOf( remoteTask.getDeviceType() ) );
							if ( remoteType == DeviceType.BACKUP_TARGET || remoteType == DeviceType.BACKUP_SOURCE ) {
								minVersion = new MinimalVersion("V05", "Validator version not supports " + remoteType.getLabel() + " devices.");
							}
							checkAndDisplayResult( newResultStr, out, devID, minVersion );
						}
						catch ( InterruptedException e ) {
							Helper.ERRORLOG( "RemoteHttpTask exception: ", Helper.throwable2String( e ) );
							out.println( "<FONT color=red>PROBLEM with recursive calling:" + Helper.throwable2String( e ) + "</FONT><BR><BR>" );
						}
					}
				}
			}
		}
		else {
	%><BR>
	<FORM method=get>
		<INPUT type=HIDDEN name="op" value="Recursive"> 
		<INPUT type=HIDDEN name="validID" value="<%=System.currentTimeMillis() + "_" + Helper.getCounter()%>">
		<INPUT type=submit value="Recursive validation">
	</FORM>
	<%
		}
		if ( !isRecursive ) {
	%>
</BODY>
</HTML>
<%
	}
%>
